# -*- coding: utf-8 -*-
"""
Created on Fri Aug 10 14:21:33 2018

@author: Usuario
"""


from pyqtgraph.Qt import QtCore, QtGui
import numpy as np
import pyqtgraph as pg
import cv2
from PyQt5.QtCore import QTimer

cap = cv2.VideoCapture(1)

n = int(1e2)
data = np.zeros(n)
i = 0

def capture():
    ret, frame = cap.read()
    #frame = cv2.resize(frame, None, fx = 0.5, fy = 0.5, interpolation = cv2.INTER_CUBIC)
    gray_image = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)
    return gray_image

def updateImage():
    im1.setImage(capture(), cmap = 'Gray')
    updateRoi(lastRoi)
    
## create GUI
app = QtGui.QApplication([])
w = pg.GraphicsWindow(size=(800,800), border=True)
v = w.addViewBox(colspan=2)
v.invertY(True)  ## Images usually have their Y-axis pointing downward
v.setAspectLocked(True)
im1 = pg.ImageItem(capture())
v.addItem(im1)




imgTimer = QTimer()
imgTimer.timeout.connect(updateImage)
imgTimer.start(10)

im2 = pg.ImageItem()
v2 = w.addViewBox(1,0)
v2.addItem(im2)


p = w.addPlot(row = 3, col = 0,  title="Updating plot")
p.setRange(QtCore.QRectF(0, -10, 5000, 20)) 
p.setAutoPan(y=True)
p.setRange(xRange = (0, n), yRange = (0, 255))

curve = p.plot(pen='y')


lastRoi = None

def updateRoi(roi):
    global im1, im2, lastRoi, data, i, curve
    if roi is None:
        return
    lastRoi = roi
    roiSlice = roi.getArrayRegion(im1.image, img=im1)
    im2.setImage(roiSlice)
    newData = np.mean(roiSlice)
    data[i] = newData
    i = np.mod(i + 1, len(data))
    curve.setData(data)
    app.processEvents()  ## force complete redraw for every plot
   

def updateRoiPlot(data):
    global curve
    curve.setData(data)
    app.processEvents()  ## force complete redraw for every plot
        
rois = []
#rois.append(pg.EllipseROI([110, 10], [30, 20], pen=(3,9)))
rois.append(pg.TestROI([0,  0], [20, 20], pen=(0,9)))


## Add each ROI to the scene and link its data to a plot curve with the same color
for r in rois:
    v.addItem(r)
    #c = pi1.plot(pen=r.pen)
    #r.curve = c
    r.sigRegionChanged.connect(updateRoi)

def updateImage():
    global im1, arr, lastRoi
    r = abs(np.random.normal(loc=0, scale=(arr.max()-arr.min())*0.1, size=arr.shape))
    im1.updateImage(arr + r)
    updateRoi(lastRoi)
    #updateRoiPlot(data)
    
if cv2.waitKey(1) & 0xFF == ord('q'):
        cap.release()
        cv2.destroyAllWindows()

w.show()


## Start Qt event loop unless running in interactive mode or using pyside.
if __name__ == '__main__':
    import sys
    if (sys.flags.interactive != 1) or not hasattr(QtCore, 'PYQT_VERSION'):
        QtGui.QApplication.instance().exec_()
